'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 138,175,281,444,761,920
'<Header End>

'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                 ADWINPRO2TDrv_arm.INC                       #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Driver functions (running on the processor T11)   #
'#            for communicating with the TiCo processor        #
'#                                                             #
'#  ??.03.2006  MG  creation                                   #
'#  18.07.2006  MF  update for xilinix >0.30                   #
'#  19.07.2006  MF  bugfix adbload                             #
'#  19.07.2006  MF  at Set_Par : P2_sleep removed              #
'#  19.07.2006  MF  bugfix Process_start/stop/status           #
'#  20.07.2006  JK  32000000H, 3240E010H replaced by #define   #
'#  20.07.2006  JK             3340E010H replaced by #define   #
'#  20.07.2006  JK  unnecessary parentheses removed            #
'#  21.07.2006  MF  P2_GETDATA , P2_SETDATA                    #
'#  27.07.2006  PR  bugfix in SUB P2_reset_uCore               #
'#  04.08.2006  TN  Proc_No defined 1..n, P2_ADBload as a      #
'#                  FUNCTION with error codes                  #
'#  08.08.2006  TN  P2_ADBload: 33 Longs for pm subtracted for #
'#                             future use and start address 1. #
'#                             1 Long for dm subtracted        #
'#  05.09.2006  MG  P2_Set_Comm_Event                          #
'#  06.09.2006  JK  P2_Start / Stop_Process_No_Comm            #
'#  06.09.2006  JK  P2_Set_Processdelay_No_Comm                #
'#  18.09.2006  MF  P2_SET_PAR_BLOCK                           #
'#  18.09.2006  MF  P2_SET_Mem_BLOCK                           #
'#  18.10.2006  JK  vars and comments translated to English    #
'#  19.12.2006  MG  P2_Workload for separate modules           #
'#  14.02.2007  MF  P2_GetDATA P2_SETDATA DM_extern            #
'#  15.02.2007  MF  P2_TDRV_INIT,P2_GetDATA P2_SETDATA         #
'#  16.02.2007  MF  P2_Workload                                #
'#  20.02.2007  MF  DEBUG_CODE GET/SETDATA                     #
'#  21.02.2007  MF  P2_TDRV_INIT                               #
'#  12.03.2007  MF/JK  P2_Get_TiCo_Status                      #
'#  13.03.2007  MF  Bug P2_get_uCore_Register                  #
'#  28.03.2007  MF  Get/Set_DATA  extern mem                   #
'#                  (required TiCo Core >=52                   #
'#  30.03.2007  MF  P2_Get_TiCo_RingBuffer Set_TiCo_RingBuffer #
'#  04.04.2007  JK  P2_Get_TiCo_RingBuffer, P2_RingBuffer_FULL #
'#  05.04.2007  JK  comment: tdrv_datatable                    #
'#  10.04.2007  JK  DEBUG_CODE : P2_Get / Set_TiCo_RingBuffer  #
'#  14.05.2007  MF  designed for ADbasic 5                     #
'#  16.05.2007  MF  P2_TiCO_START/STOP/RESET                   #
'#  24.05.2007  MF  ADR Com Event changed required Tico >=1.0  #
'#  23.07.2007  ur  tdrv_datatable with 150elements            #
'#  25.07.2007  mf  p2_set_data                                #
'#  26.07.2007  mf  P2_Reset_uCore                             #
'#  02.08.2007  mf  P2_RingBuffer_Empty                        #
'#  16.08.2007  ur  proc_no renamed to tico_no                 #
'#  22.08.2007  mf  P2_Set_TiCo_RingBuffer                     #
'#  06.09.2007  mf  P2_GET_SET_DATA                            #
'#  19.10.2007  mf  SET_COMM_EVENT => SET_Master_EVENT         #
'#  06.12.2007  mf  P2_TiCo_Start_Process                      #
'#  06.12.2007  mf  P2_TiCo_Stop_Process                       #
'#  06.12.2007  mf  P2_TiCo_Set_Processdelay                   #
'#  06.12.2007  mf  P2_TiCo_Get_Processdelay                   #
'#  14.03.2008  mf  P2_GET_DATA_LONG                           #
'#  20.03.2008  gc  names of sub/func parameter revised        #
'#  11.04.2008  mf  no_master removed                          #
'#  06.01.2009  mf  P2_SET_DATA_long exten SRAM kompatibel     #
'#  06.01.2009  mf  P2_Get_DATA_long exten SRAM kompatibel     #
'#  28.01.2009  mf  P2_Get_TiCo_RingBuffer SRAM kompatibel     #
'#  20.03.2009  mf  '''+                                       #
'#  13.05.2009  mf  bugfix P2_SET_TICO_RingBuffer              #
'#  23.10.2009  mf  Check_Type_Long(tdrv_datatable[1])         #
'#  26.01.2010  mf  optimize get_data                          #
'#  28.01.2010  mf  optimize set_data                          #
'#  29.01.2010  mf  P2_TiCo_Reset =>P2_TiCo_Restart            #
'#  09.02.2010  mf  End_Exit by PROZESS_FEHLER                 #
'#  10.02.2010  mf  new function P2_TiCo_Get_Array_Length      #
'#  16.02.2010  mf  System_Array_Debug_Check beta              #
'#  02.03.2010  mf  optimize P2_TiCo_Get/Set_Processdelay      #
'#  02.03.2010  mf  optimize P2_TiCo_Start/Stop_Proces         #       
'#  11.03.2010  mf  p2_TDRV_Init Debug optimize                #
'#  25.05.2010  mf  optimize p2_work_laod                      #
'#  07.07.2010  mf  optimize p2_get/set_data                   #
'#  27.07.2010  mf  optimize get/set/full ringbuffer           #
'#  24.06.2013  mf  T12 beta (nur einige Befehle)              #
'#  06.01.2015  mf  T12 ready                                  #
'#  07.05.2015  mf GET/Set Data /par support float/float32     #
'#  06.07.2015  ap  variable names/docu correction ringbuffer  #
'#  26.08.2015  mf  get_par_block and get_data support fifo    #
'#  04.02.2016  mf P2_TiCo_Get_Process_Error                   #
'#  19.01.2021  mf bugfix p2_tdrv_init                         #
'#  13.02.2023  jk  only comment changed at P2_Test_Version    #
'#                                                             #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'###############################################################

'<REGION> Declaration
' -------------- tdrv_datatable --------------------------------
' Many functions / subroutines in this file are requiring and
' using an array called "tdrv_datatable"
' For more information on it, please see in the manual at the
' subroutine "P2_TDRV_INIT()"
' Summarily :
' tdrv_datatable is an array with 150 elements of typ Long.
' It is required for the communication between T11 and TiCo,
' because communication settings are stored in it.
' If communication to several TiCo processor should be done,
' then there are also seperate tdrv_datatables required for
' each TiCo. For example :
'    tdrv_datatable_41    for TiCo number 1 on module 4
'    tdrv_datatable_71    for TiCo number 1 on module 7
' --------------------------------------------------------------

#define TDRV_POFFSET 22 ''<HIDE>

'************************************************
' Hardware
'*************************************************
' Addresses for access on internal TiCo-RAM

#define Addr_TiCo_Master_Event          680E2E00H 
#define Addr_TiCo_Set_Write_pointer     600E0000H 
#define Addr_TiCo_Set_Write_pointer_EXT 60070800H 
#define Addr_TiCo_Set_Read_pointer      600E0010H 
#define Addr_TiCo_Set_Read_pointer_EXT  60070850H 
#define Addr_TiCo_Write_Burst           60000000H 
#define Addr_TiCo_Write_Burst_Count     640E0100H 
#define Addr_TiCo_Write_Burst_Count_EXT 64070900H 
#define Addr_TiCo_Read_Burst_Count      640E0104H 
#define Addr_TiCo_Read_Burst_Count_EXT  64070904H 
#define Addr_TiCo_Comm_Event            680E2E00H


'<ENDREGION>

'<REGION> TiCo control
'********************************************************************
'''Stops TiCo.
'''module_pattern: bit pattern to set the module addresses
'''******************************************************************
SUB P2_TiCo_Stop(module_pattern)
  POKE(680E0000h, module_pattern)
ENDSUB

'********************************************************************
'''Starts TiCo. Program must be loaded before.
'''module_pattern: bit pattern to set the module addresses
'''******************************************************************
SUB P2_TiCo_Start(module_pattern)
  POKE(680E0010h, module_pattern)
ENDSUB

'********************************************************************
'''Resets TiCo (stop/start). TiCo program must be loaded before.
'''module_pattern: bit pattern to set the module addresses
'''******************************************************************
SUB P2_TiCo_Reset(module_pattern) ''<HIDE>
  POKE(680E0000h, module_pattern)
  POKE(680E0010h, module_pattern)  
ENDSUB


'********************************************************************
'''Restarts TiCo (stop/start). TiCo program must be loaded before.
'''module_pattern: bit pattern to set the module addresses
'''******************************************************************
SUB P2_TiCo_Restart(module_pattern) 
  POKE(680E0000h, module_pattern)
  POKE(680E0010h, module_pattern)
ENDSUB
'<ENDREGION>

'<REGION> Helper functions
'********************************************************************
' Helper Funktionen only internal use
'********************************************************************
SUB P2_Reset_uCore(module)   ''<HIDE>
  Check_Card(module)
  
  ' generate a falling edge for the core-reset-logic
  POKE (680E0000h OR shift_left(module, 20), 0)
  p2_sleep(100)
  POKE (680E0000h OR shift_left(module, 20), 1)
  POKE (680E0010h, shift_left(1, module - 1))
  p2_sleep(100)  
ENDSUB

'FUNCTION P2_Get_uCore_Register(module, adr) AS Long 'todo: noch nicht zumgesetzt , wo wird diese Funktion verwendet?
' 
'#if prozessor=t11
'  
'  Check_Card(module)
'  SUB_BEGIN_CRITICAL_SECTION
'  Poke_Fast_Bus((adr) or shift_left(module,16), 0)
'  READ_FAST_BUS(P2_get_uCore_Register, 1)
'  SUB_END_CRITICAL_SECTION
'  
'#else
'  *errror
'#endif
'  
'ENDFUNCTION
'<ENDREGION>

'<REGION> General
'******************************************************************************
'''Checks if a pro II module exists on this address.
'''+Return 
'''+        0 module exist
'''+        1 no module exist
'''module: module address (1..15).
'''****************************************************************************
FUNCTION P2_Test_Version(module) as Long
  Check_Card(module)
  if (p2_check_led(module) <> 12345678H) then
    P2_Test_Version = 0 'ok
  else
    P2_Test_Version = 1 'error
  endif
ENDFUNCTION


'******************************************************************************
''' Reads TiCo Status.
'''+Return 
'''+        -3 = no TiCo on this module
'''+        -2 = no Pro 2 modul exists (Timeout)
'''+        >0 = each bit corresponds to a TiCo (1= TiCo 1 run)
'''module: module address (1..15).
'''****************************************************************************
FUNCTION P2_Get_TiCo_Status(module) as Long
  dim count, a1_1, a1_2 as Long
  Check_Card(module)
  count = Peek_P2 (6800E000h OR shift_left(module, 20))

  if (count = 12345678H) then
    P2_GET_TiCo_Status = -2
  else
    if (count = 0) then
      P2_GET_TiCo_Status = -3
    else
      SUB_BEGIN_CRITICAL_SECTION
      a1_1 = Peek_P2 (680E2200h OR shift_left(module, 20))
      a1_2 = Peek_P2 (680E2200h OR shift_left(module, 20))
      SUB_END_CRITICAL_SECTION
      
      if (a1_1 = a1_2) then
        P2_GET_TiCo_Status = 0
      else
        P2_GET_TiCo_Status = 1
      endif
    endif
  endif
ENDFUNCTION

'******************************************************************************
'''Initialises the data transfer between the ADwin CPU and a TiCo processor.
'''module: module address (1..15).
'''tico_no: TiCo number (1..n).
'''tdrv_datatable[]: array with 150 elements of type Long . 
'''****************************************************************************
Sub P2_TDrv_Init(module, tico_no, tdrv_datatable[])
  Check_Type_Long (tdrv_datatable[1])
  Check_Card(module)
  System_Array_Debug_Check(tdrv_datatable, 1, 150)
  p2_System_PROII_Bus_Set_Timeout()
  P2_TDRV_INIT_int(module, tico_no, tdrv_datatable)
  
#IF DEBUG_MODE = ON THEN
  if (tdrv_datatable[90] <> 16) then
    PROZESS_FEHLER = 210500  '  "TiCo Datatable does not exist"
    end_exit
  endif
#ENDIF

endsub
'<ENDREGION>

'<REGION> Par access
'******************************************************************************
'''Returns the value of the global variable PAR_x of a TiCo processor of the specified module.
'''module: module address (1..15).
'''tico_no: TiCo number (1..n).
'''par_no: number of parameter to be read.
'''****************************************************************************
FUNCTION P2_Get_Par(module, tico_no, par_no) as Long 
  Check_Card(module)


  SUB_BEGIN_CRITICAL_SECTION
  poke(shift_left(module, 20) OR Addr_TiCo_Set_Read_pointer, par_no + TDRV_POFFSET) 
  Read_Fast_Bus_LB_nocritL(P2_Get_Par, 1, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
  SUB_END_CRITICAL_SECTION

ENDFUNCTION

'******************************************************************************
'''Transfers a number of global Long variables, which is to be indicated, into an array.
'''module: module address (1..15).
'''tico_no: TiCo number (1..n).
'''dest_array[]: destination array.
'''dest_array_idx: startindex in destination array.
'''startindex: number of first value to be transferred.
'''count: number of variables to be transferred.
'''****************************************************************************
SUB P2_Get_Par_Block(module, tico_no, dest_array[], dest_array_idx, startindex, count) 
  Check_Card(module)
 
  System_Array_Debug_Check(dest_array, dest_array_idx, count)
  
  SUB_BEGIN_CRITICAL_SECTION
  poke(shift_left(module, 20) OR Addr_TiCo_Set_Read_pointer, Startindex + TDRV_POFFSET)
  
  if (if_type_fifo(dest_array)=1)  then   
    Read_Fast_Bus_LB_nocritXF(get_array_no(dest_array), count, Addr_TiCo_Read_Burst_Count or shift_left(module, 20))
  else
    
    
    if (if_type_long (dest_array) = 1) then 
      Read_Fast_Bus_LB_nocritL(dest_array[dest_array_idx], count, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
    endif
  
    if (if_type_float (dest_array) = 1) then 
      Read_Fast_Bus_LB_nocritD(dest_array[dest_array_idx], count, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
    endif
  
    if (if_type_float32 (dest_array) = 1) then 
      Read_Fast_Bus_LB_nocritF(dest_array[dest_array_idx], count, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
    endif
  
    if (if_type_short (dest_array) = 1) then 
      Read_Fast_Bus_LB_nocritS(dest_array[dest_array_idx], count, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
    endif
 
  endif
  
    
  SUB_END_CRITICAL_SECTION

ENDSUB

'******************************************************************************
'only for internal use !!!
'Transfers a number of global registers, which is to be indicated, into an array.
'module: module address (1..15)
'tico_no: TiCo number (1..n)
'dest_array: destination array
'dest_array_idx: startindex in destination array
'startindex: number of first value to be transferred
'count: number of variables to be transferred
'******************************************************************************
SUB P2_Get_Mem_Block(module, tico_no, dest_array[], dest_array_idx, startindex, count)   ''<HIDE>
  Check_Card(module)
  System_Array_Debug_Check(dest_array, dest_array_idx, count)
  SUB_BEGIN_CRITICAL_SECTION
  poke(shift_left(module, 20) OR Addr_TiCo_Set_Read_pointer, Startindex)
  Read_Fast_Bus_LB_nocritL(dest_array[dest_array_idx], count, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
'''Sets a global Long variable to the specified value.
'''module:  module address (1..15)
'''tico_no: TiCo number (1..n)
'''par_no:  number of global Long variable
'''value: Value (-2^31.+2^31-1) of the globale variable
'''****************************************************************************
SUB P2_Set_Par(module, tico_no, par_no, value) 'todo burst
  Check_Card(module)
  
  dim v1[1] as long
  
  SUB_BEGIN_CRITICAL_SECTION
  Poke(Addr_TiCo_Set_Write_pointer OR shift_left(module, 20), par_no + TDRV_POFFSET)
  
  v1[1] = value
  Write_Fast_Bus_LB_nocritL(v1[1], 1, ((Addr_TiCo_Write_Burst_Count) or shift_left(module, 20)))
  SUB_END_CRITICAL_SECTION



ENDSUB

'******************************************************************************
'''Transfers an array to a number of global Long variables.
'''module:   module-address (1..15)
'''tico_no: TiCo number (1..n)
'''src_array[]: source array
'''src_array_idx: start index in source array
'''par_no: number of first parameter value to be transferred
'''count: number of variables to be transferred
'''****************************************************************************
SUB P2_Set_Par_Block(module, tico_no, src_array[], src_array_idx, par_no, count)
  Check_Card(module)
  System_Array_Debug_Check(src_array, src_array_idx, count)
  
  SUB_BEGIN_CRITICAL_SECTION
  Poke(Addr_TiCo_Set_Write_pointer OR shift_left(module, 20), par_no + TDRV_POFFSET)

  if (if_type_long (src_array) = 1) then 
    Write_Fast_Bus_LB_nocritL(src_array[src_array_idx], count, ((Addr_TiCo_Write_Burst_Count) or shift_left(module, 20)))
  endif
  
  if (if_type_float (src_array) = 1) then 
    Write_Fast_Bus_LB_nocritD(src_array[src_array_idx], count, ((Addr_TiCo_Write_Burst_Count) or shift_left(module, 20)))
  endif
    
  if (if_type_float32 (src_array) = 1) then 
    Write_Fast_Bus_LB_nocritF(src_array[src_array_idx], count, ((Addr_TiCo_Write_Burst_Count) or shift_left(module, 20)))
  endif
  
  if (if_type_short (src_array) = 1) then 
    Write_Fast_Bus_LB_nocritS(src_array[src_array_idx], count, ((Addr_TiCo_Write_Burst_Count) or shift_left(module, 20)))
  endif
  
  
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
'only for internal use !!!
'Transfers a number of array values into global registers.
'module: module address (1..15).
'tico_no: TiCo number (1..n).
'src_array: source array.
'src_array_idx: startindex in source array.
'reg_addr: number of first value to be transferred.
'count: number of variables to be transferred.
'******************************************************************************
SUB P2_Set_Mem_Block(module, tico_no, src_array[], src_array_idx, reg_addr, count)   ''<HIDE>
  Check_Card(module)
  System_Array_Debug_Check(src_array, src_array_idx, count)
  
  SUB_BEGIN_CRITICAL_SECTION
  Poke(Addr_TiCo_Set_Write_pointer OR shift_left(module, 20), reg_addr)
  Write_Fast_Bus_LB_nocritL(src_array[src_array_idx], count, ((Addr_TiCo_Write_Burst_Count) or shift_left(module, 20)))
  SUB_END_CRITICAL_SECTION
  
ENDSUB
'<ENDREGION>

'<REGION> Process control
'******************************************************************************
'
'module: module address (1..15)
'tico_no: TiCo number (1..n)
'process_no: number of process(1..4)
'value:
'******************************************************************************
SUB P2_Set_Processdelay(module, tico_no, process_no, value) ''<HIDE>  
  

  dim v1[1] as long
  Check_Card(module)
  v1[1] = value
  SUB_BEGIN_CRITICAL_SECTION
  Poke(Addr_TiCo_Set_Write_pointer OR shift_left(module, 20), process_no + 151)
  Write_Fast_Bus_LB_nocritL(v1[1], 1, ((Addr_TiCo_Write_Burst_Count) or shift_left(module, 20)))
  SUB_END_CRITICAL_SECTION
  
  POKE(Addr_TiCo_Master_Event or shift_left(module, 20), 1)

ENDSUB

'******************************************************************************
'''Sets the Processdelay (cycle time) of a TiCo process on the specified module.
'''+before use, please first call P2_TDRV_INIT
'''tdrv_datatable[]: array with 150 elements of type Long 
'''process_no: number of process (1..4)
'''value: Processdelay in ticks
'''****************************************************************************
SUB P2_TiCo_Set_Processdelay(tdrv_datatable[], process_no, value) 
  dim module_s as long
  
#if prozessor = t12
  dim v1[1] as long
#endif
  
  
  Check_Type_Long (tdrv_datatable[1])
  
  module_s = shift_left(tdrv_datatable[85], 20)

  Check_Card(tdrv_datatable[85])
 

  SUB_BEGIN_CRITICAL_SECTION
  Poke(Addr_TiCo_Set_Write_pointer OR module_s, process_no + 151)
  v1[1] = value
  Write_Fast_Bus_LB_nocritL(v1[1], 1, Addr_TiCo_Write_Burst_Count or module_s)
  SUB_END_CRITICAL_SECTION
    
  
  If (tdrv_datatable[64 + process_no] AND 1 = 0) then
    POKE(Addr_TiCo_Master_Event or module_s, 1)
  endif
ENDSUB

'******************************************************************************
'''Returns the Processdelay (cycle time) of a process on a TiCo processor on the specified module.
'''+Before use, please first call P2_TDRV_INIT
'''tdrv_datatable[]: array with 150 elements of type Long  (see comment at the top
'''process_no: number of process (1..4)
'''******************************************************************************
FUNCTION P2_TiCo_Get_Processdelay(tdrv_datatable[], process_no) as Long
  DIM status as Long
  dim module_s as long
  
  Check_Type_Long (tdrv_datatable[1])
  Check_Card(tdrv_datatable[85])
  
  module_s = shift_left(tdrv_datatable[85], 20)

  SUB_BEGIN_CRITICAL_SECTION
  poke(module_s OR Addr_TiCo_Set_Read_pointer, process_no + 151) 
  Read_Fast_Bus_LB_nocritL(status, 1, Addr_TiCo_Read_Burst_Count or module_s) 
  SUB_END_CRITICAL_SECTION
  
  P2_TiCo_Get_Processdelay = status

ENDFUNCTION

FUNCTION P2_Get_Processdelay(module, tico_no, process_no) as Long ''<HIDE>
  DIM status as Long
  Check_Card(module)

  SUB_BEGIN_CRITICAL_SECTION
  poke(shift_left(module, 20) OR Addr_TiCo_Set_Read_pointer, process_no + 151) 
  Read_Fast_Bus_LB_nocritL(status, 1, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
  SUB_END_CRITICAL_SECTION
  P2_Get_Processdelay = status
 
ENDFUNCTION

'******************************************************************************
'''Returns the Processdelay (cycle time) of a process on a TiCo processor on the specified module.
'''+Before use, please first call P2_TDRV_INIT
'''tdrv_datatable[]: array with 150 elements of type Long  (see comment at the top
'''process_no: number of process (1..4)
'''******************************************************************************
FUNCTION P2_TiCo_Get_Process_Error(tdrv_datatable[], process_no) as Long ''<HIDE>
  DIM status as Long
  dim module_s as long
  
  Check_Type_Long (tdrv_datatable[1])
  Check_Card(tdrv_datatable[85])
  
  module_s = shift_left(tdrv_datatable[85], 20)

  SUB_BEGIN_CRITICAL_SECTION
  poke(module_s OR Addr_TiCo_Set_Read_pointer, process_no + 171) 
  Read_Fast_Bus_LB_nocritL(status, 1, Addr_TiCo_Read_Burst_Count or module_s) 
  SUB_END_CRITICAL_SECTION
  
  P2_TiCo_Get_Process_Error = status

ENDFUNCTION





''' ******************************************************************************
'''Starts a process.
'''module: module address (1..15)
'''tico_no: TiCo number (1..n)
'''process_no: number of process (1..4)
'******************************************************************************
SUB P2_Start_Process(module, tico_no, process_no)  ''<HIDE>
 
  dim v1[1] as long
  v1[1] = 1
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION  
  Poke(Addr_TiCo_Set_Write_pointer OR shift_left(module, 20), process_no + 159) 
  Write_Fast_Bus_LB_nocritL(v1[1], 1, Addr_TiCo_Write_Burst_Count or shift_left(module, 20))
  SUB_END_CRITICAL_SECTION  
  
  POKE(Addr_TiCo_Master_Event or shift_left(module, 20), 1)' necessary, if Eventsource is "Timer" or "Extern"

ENDSUB

'******************************************************************************
'''Starts a process on a TiCo processor.
'''+Before use, please first call P2_TDRV_INIT
'''tdrv_datatable[]: array with 150 elements of type Long (see comment at the top)
'''process_no: number of process (1..4)
'''****************************************************************************
SUB P2_TiCo_Start_Process(tdrv_datatable[], process_no)
  
  dim module_s as long
  
  dim v1[1] as long
  
  Check_Type_Long (tdrv_datatable[1])
  

  module_s = shift_left(tdrv_datatable[85], 20)
  
  Check_Card(tdrv_datatable[85])  


  SUB_BEGIN_CRITICAL_SECTION
  Poke(Addr_TiCo_Set_Write_pointer OR module_s, process_no + 159)
  v1[1] = 1
  Write_Fast_Bus_LB_nocritL(v1[1], 1, Addr_TiCo_Write_Burst_Count or module_s)
  SUB_END_CRITICAL_SECTION
  
  If (tdrv_datatable[64 + process_no] AND 1 = 0) then
    POKE(Addr_TiCo_Master_Event or module_s, 1)' necessary, if Eventsource is "Timer" or "Extern" 
  endif
ENDSUB

'******************************************************************************
'''Stops a process on a TiCo processor.
'''+Before use, please first call P2_TDRV_INIT
'''tdrv_datatable[]: array with 150 elements of type Long  (see comment at the top)
'''process_no: number of process (1..4)
'''****************************************************************************
SUB P2_TiCo_Stop_Process(tdrv_datatable[], process_no)
  
  dim module_s as long 
  DIM status as Long
  dim v1[1] as long
  Check_Type_Long (tdrv_datatable[1])



  module_s = shift_left(tdrv_datatable[85], 20)

  Check_Card(tdrv_datatable[85]) '
  

  SUB_BEGIN_CRITICAL_SECTION
  poke(module_s OR Addr_TiCo_Set_Read_pointer, process_no + 159) 
  Read_Fast_Bus_LB_nocritL(status, 1, Addr_TiCo_Read_Burst_Count or module_s) 
  
  if (status = 1) then
    Poke(Addr_TiCo_Set_Write_pointer OR module_s, process_no + 159)
    
    v1[1] = -1
    Write_Fast_Bus_LB_nocritL(v1[1], 1, Addr_TiCo_Write_Burst_Count or module_s)
  endif
  
  SUB_END_CRITICAL_SECTION
  
  
  If (tdrv_datatable[64 + process_no] AND 1 = 0) then
    POKE(Addr_TiCo_Master_Event or module_s, 1)' necessary, if Eventsource is "Timer" or "Extern"
  endif
ENDSUB

'******************************************************************************
'Stops a process.
'module: module address (1..15)
'tico_no: TiCo number (1..n)
'process_no: number of process (1..4)
'******************************************************************************
SUB P2_Stop_Process(module, tico_no, process_no) ''<HIDE>
  Check_Card(module)
  dim status as long
  dim v1[1] as long
   
  SUB_BEGIN_CRITICAL_SECTION
  poke(shift_left(module, 20) OR Addr_TiCo_Set_Read_pointer, process_no + 159) 
  Read_Fast_Bus_LB_nocritL(status, 1, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
  
  if (status = 1) then 
    Poke(Addr_TiCo_Set_Write_pointer OR shift_left(module, 20), process_no + 159)
   
    v1[1] = -1
    Write_Fast_Bus_LB_nocritL(v1[1], 1, Addr_TiCo_Write_Burst_Count or shift_left(module, 20))
  
  endif
  
  SUB_END_CRITICAL_SECTION

 
  POKE(Addr_TiCo_Master_Event or shift_left(module, 20), 1)' necessary, if Eventsource is "Timer" or "Extern"




ENDSUB

'******************************************************************************
'''Returns the status of a TiCo process.
'''module: module address (1..15)
'''tico_no: TiCo number (1..n)
'''process_no: number of process (1..4)
'''****************************************************************************
FUNCTION P2_Process_Status(module, tico_no, process_no) as Long
  Check_Card(module)
  
  SUB_BEGIN_CRITICAL_SECTION
  poke(shift_left(module, 20) OR Addr_TiCo_Set_Read_pointer, process_no + 159) 
  Read_Fast_Bus_LB_nocritL(P2_Process_Status, 1, Addr_TiCo_Read_Burst_Count or shift_left(module, 20)) 
  SUB_END_CRITICAL_SECTION
ENDFUNCTION

'******************************************************************************
'''Returns the processor workload.
'''+Before use, please first call P2_TDRV_INIT
'''tdrv_datatable[]: array with 150 elements of type Long  
'''****************************************************************************
FUNCTION P2_Workload(tdrv_datatable[]) as Float
  DIM time, counter, help_time, help_counter as Long
  dim module as Long
  dim proc_no as Long
  dim kor, i, d, s as long
  
  Check_Type_Long (tdrv_datatable[1])
  module = tdrv_datatable[85]
  proc_no = tdrv_datatable[86]
  Check_Card(module)
  

  SUB_BEGIN_CRITICAL_SECTION
  time = Peek_P2 (680E2200h OR shift_left(module, 20))
  counter = Peek_P2 (680E2400h OR shift_left(module, 20))
  SUB_END_CRITICAL_SECTION


  help_time = time - tdrv_datatable[87]
  help_counter = counter - tdrv_datatable[88]
  
  kor = 0
  if (tdrv_datatable[91] = 1) then
    for i = 1 to 4
      s = P2_Process_Status(module, proc_no, i)
      if (s = 1) then 'luft process i?
      
        'Bit 2-4:
        '000 Timer
        '001 Extern
        '010 None
        if (tdrv_datatable[64 + i] AND 11100B = 0) then 'nur bei timer process kor 
          d = help_time / P2_Get_Processdelay(module, proc_no, i) 'as Long 
          kor = kor + d
        endif
      endif
    next
    help_counter = help_counter - kor
  endif
  
  
  if (help_time = 0) then
    P2_WorkLoad = -1
  else
    P2_WorkLoad = 100 * (1 - help_counter / help_time)
  endif
  if (p2_Workload > 100) then p2_workload = 100
  
  tdrv_datatable[87] = time
  tdrv_datatable[88] = counter
ENDFUNCTION
'<ENDREGION>

'<REGION> Data
'******************************************************************************
'''Reads values from a global array of a TiCo processor and writes the values into a specified array.
'''+Before use, please first call P2_TDRV_INIT.
'''tdrv_datatable[]: array with 150 elements of type Long.  
'''src_array_no: source(TiCo) array number (1..16).
'''src_array_idx: number of first array element to be transferred.
'''count: number of data elements to be transferred.
'''dest_array[]: destination array.
'''dest_array_idx: startindex in the destination array.
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''******************************************************************************
SUB P2_GetData_Long(tdrv_datatable[], src_array_no, src_array_idx, count, dest_array[], dest_array_idx, flowrate)
  
 
#IF DEBUG_MODE = ON THEN
  dim datatype_reg as long
  
  datatype_reg = tdrv_datatable[3 + 4 * (src_array_no - 1)]
  if (datatype_reg = -1) then
    PROZESS_FEHLER = 210000  '  "TiCo DATA does not exist"
    end_exit
  else
    if ((datatype_reg AND 0FFFFH) > 4) then 
      PROZESS_FEHLER = 210001   ' "TiCo DATA has wrong datatype"
      end_exit
    endif
        
    if (src_array_idx < 1) then 
      prozess_fehler = 210003              ' "TiCo DATA-index < 1"
      end_exit
    ENDIF
          
    if ((src_array_idx + count) > tdrv_datatable[4 + 4 * (src_array_no - 1)]) then 
      PROZESS_FEHLER = 210002 ' "TiCo DATA-index too large"
      end_exit
    endif
        
  endif
  
  
#ENDIF
  Check_Type_Long (tdrv_datatable[1])
 
  
  if (if_type_fifo(dest_array)=1)  then
    P2_GetData_long_Lib_Fifo(tdrv_datatable, src_array_no, src_array_idx, count, get_array_no(dest_array), dest_array_idx, flowrate)
  else  
    System_Array_Debug_Check(dest_array, dest_array_idx, count)
    if (if_type_long (dest_array) = 1) then 
      P2_GetData_long_Lib_L(tdrv_datatable, src_array_no, src_array_idx, count, dest_array, dest_array_idx, flowrate)
    endif
  
    if (if_type_short (dest_array) = 1) then 
      P2_GetData_long_Lib_S(tdrv_datatable, src_array_no, src_array_idx, count, dest_array, dest_array_idx, flowrate)
    endif
  
    if (if_type_float32 (dest_array) = 1) then 
      P2_GetData_long_Lib_F(tdrv_datatable, src_array_no, src_array_idx, count, dest_array, dest_array_idx, flowrate)
    endif
  
    if (if_type_float (dest_array) = 1) then 
      P2_GetData_long_Lib_D(tdrv_datatable, src_array_no, src_array_idx, count, dest_array, dest_array_idx, flowrate)
    endif
  endif
  
ENDSUB

'******************************************************************************
'''Reads values from an array and writes them into a global array of a TiCo processor on the specified module.
'''+Before use, please first call P2_TDRV_INIT.
'''tdrv_datatable[]: array with 150 elements of type Long.                                                               
'''dest_array_no: destination (TiCo) array number.
'''dest_array_idx: number of first array element to be written.
'''count: number of data elements to be transferred.
'''src_array[]: source array.
'''src_array_idx: start index in the source array.
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''****************************************************************************
SUB P2_SetData_Long(tdrv_datatable[], dest_array_no, dest_array_idx, count, src_array[], src_array_idx, flowrate)
#IF DEBUG_MODE = ON THEN
  dim datatype_reg as long
  datatype_reg = tdrv_datatable[3 + 4 * (dest_array_no - 1)]
  
  if (datatype_reg = -1) then
    PROZESS_FEHLER = 210020   '  "TiCo DATA does not exist"
    end_exit
  else
    if ((datatype_reg AND 0FFFFH) > 4) then
      PROZESS_FEHLER = 210021 ' "TiCo DATA has wrong datatype"
      end_exit
    endif
        
    if (dest_array_idx < 1) then 
      prozess_fehler = 210023             ' "TiCo DATA-index < 1"
      end_exit
    endif
        
    if ((dest_array_idx + count) > tdrv_datatable[4 + 4 * (dest_array_no - 1)]) then 
      PROZESS_FEHLER = 210022 ' "TiCo DATA-index too large"
      end_exit
    endif
        
  endif
#ENDIF
 
  Check_Type_Long (tdrv_datatable[1])

 
  if (if_type_fifo(src_array)=1)  then
    P2_SetData_long_Lib_Fifo(tdrv_datatable, dest_array_no, dest_array_idx, count, get_array_no(src_array), src_array_idx, flowrate)
  else 
    System_Array_Debug_Check(src_array, src_array_idx, count)
  
  
    if (if_type_long (src_array) = 1) then 
      P2_SetData_Long_LIB_L(tdrv_datatable, dest_array_no, dest_array_idx, count, src_array, src_array_idx, flowrate)
    endif
  
    
    if (if_type_short (src_array) = 1) then 
      P2_SetData_Long_LIB_S(tdrv_datatable, dest_array_no, dest_array_idx, count, src_array, src_array_idx, flowrate)
    endif
    
    if (if_type_float (src_array) = 1) then 
      P2_SetData_Long_LIB_D(tdrv_datatable, dest_array_no, dest_array_idx, count, src_array, src_array_idx, flowrate)
    endif
    
    if (if_type_float32 (src_array) = 1) then 
      P2_SetData_Long_LIB_F(tdrv_datatable, dest_array_no, dest_array_idx, count, src_array, src_array_idx, flowrate)
    endif
  
  endif
  
  
ENDSUB


'******************************************************************************
'''Returns the length of TiCo Data.
'''+ -2 no data exists
'''tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.
'''datano: Number (1..16) of Data on the TiCo processor.
'''******************************************************************************
FUNCTION P2_TiCo_Get_Array_Length(tdrv_datatable[], datano) as long
  dim module as long
  module = tdrv_datatable[85]
  if (par_92 <> tdrv_datatable[89]) then P2_TDRV_INIT(module, 1, tdrv_datatable)
  P2_TiCo_Get_Array_Length = tdrv_datatable[4 + 4 * ((datano) - 1)] - 1  ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
ENDFUNCTION

'<ENDREGION>

'<REGION> Ringbuffer
'******************************************************************************
'''Reads values from a ringbuffer of a TiCo processor and writes the values into an array of ADwin CPU.
'''+Before use, please first call P2_TDRV_INIT.
'''+return: -1 error, >= 0 number of transferred values.
'''tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.                                                         
'''src_array_no: source(TiCo) array number.
'''dest_array[]: destination array.
'''dest_array_idx: startindex in the destination array.
'''maxcount: Max. number (1..n) of transferred values.
'''flowrate: 
'''+          1=low
'''+          2=medium
'''+          3=fast
''' tico_par: Code number to transfer the read pointer to the TiCo processor.
'''+       1.80: Number (1.80) of global variable Par_n of the TiCo processor, into which the current read pointer value is written.
'''+       0: Read pointer value is not transferred
'''structure: Read block size:
'''+        0: Read arbitrary number of values.
'''+       >0: The number of transferred values must be a multiple of structure.
'''******************************************************************************
FUNCTION P2_Get_TiCo_RingBuffer(tdrv_datatable[], src_array_no, dest_array[], dest_array_idx, maxcount, flowrate, tico_par, structure) as Long
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long ' RAM  2 = intern 3 = extern
  dim datatype_reg as Long
  dim size as Long         ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  dim module as Long
  dim ticonr as Long
  dim tindex as Long ' writepointer ( at first :  = absolute address in TiCo memory)
  '                                 ( later :  = rel. addr. in TiCo mem. ; range : 1 ... size )
  dim count as Long
  dim count1 as Long
  dim count2 as Long
  dim write_registernr as Long
  dim regnr2 as Long         ' position of rel_read_pointer in tdrv_datatable
  dim rel_read_pointer as Long ' pointer relative to the start of the array :  1 ... n
  dim buffer_full as Long
  dim max as Long
  dim base as long
#IF DEBUG_MODE = ON THEN
  dim read_registernr as Long
#ENDIF
  Check_Type_Long (tdrv_datatable[1])
 
  datapointer = tdrv_datatable[1 + 4 * (src_array_no - 1)] ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  datalocation = tdrv_datatable[2 + 4 * (src_array_no - 1)] ' RAM     2 = intern 3 = extern 4=sram_extern
  datatype_reg = tdrv_datatable[3 + 4 * (src_array_no - 1)]
  size = tdrv_datatable[4 + 4 * (src_array_no - 1)] - 1 ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  module = tdrv_datatable[85]
  ticonr = tdrv_datatable[86]
  ' which TiCo Indexreg is used as a write pointer ?  Actually possible values : 1, 2
  write_registernr = shift_right(datatype_reg, 16) AND 0FFH
  if (write_registernr <> 0) then  ' Check : is this ringbuffer declared in TiCo for writing ? If not : do nothing
#IF DEBUG_MODE = ON THEN
    read_registernr = shift_right(datatype_reg, 24)
    if (read_registernr <> 0) then  ' Check : is this ringbuffer declared in TiCo also for reading ?
      ' Yes ! This means, that the TiCo AS WELL AS this function wants to read
      ' from the ringbuffer. This will cause trouble  =>
      PROZESS_FEHLER = 210100  '  "TiCo Ringbuffer is declared as READ and WRITE"
      end_exit
    endif
#ENDIF
    if (datalocation = 3) then ' RAM  2 = intern or sram
      regnr2 = 78 + write_registernr
    

      base = 680E5000h

      
    else                      ' RAM  3 = extern dram
      regnr2 = 74 + write_registernr
    
      base = 680E4000h


    endif
    rel_read_pointer = tdrv_datatable[regnr2] ' pointer relative to the start of the array :  1 ... n
    count1 = 0
    count = 0
    count2 = 0

    'tindex = p2_get_uCore_Register(module,(base+32*(write_registernr-1))) ' get TiCos Index1 or Index2 Register


    tindex = Peek_P2 ((base + 512 * (write_registernr - 1)) or shift_left(module, 20))

    tindex = tindex - datapointer ' writepointer ( = relative address in TiCo memory ; range : 1 ... size )
    buffer_full = tindex - rel_read_pointer ' number of elements, which the ringbuffer contains
    if (buffer_full < 0) then buffer_full = buffer_full + size ' turnaround - check
    
    max = min_long(buffer_full, maxcount)
    
    IF (structure > 0) then max = (max / structure) * structure
    'if (tindex = rel_read_pointer) not necessary to handle this case, bec. then the ringbuffer is empty
    if (tindex < rel_read_pointer) then
      count = min_long((size - rel_read_pointer + 1), max)
      count1 = count
      if (count > 0) then
        P2_GETData_Long(tdrv_datatable, src_array_no, rel_read_pointer, count, dest_array, dest_array_idx, flowrate)
        rel_read_pointer = rel_read_pointer + count
        if (rel_read_pointer > size) then rel_read_pointer = 1   '
      endif
    endif
    if (tindex > rel_read_pointer) then
      count = min_long((tindex - rel_read_pointer + 1), (max - count1))
      count2 = count
      if (count > 0) then
        P2_GetData_Long(tdrv_datatable, src_array_no, rel_read_pointer, count, dest_array, dest_array_idx + count1, flowrate)
        rel_read_pointer = rel_read_pointer + count
      endif
    endif
    P2_GET_TICO_RingBuffer = count2 + count1
    tdrv_datatable[regnr2] = rel_read_pointer
    if ((tico_par > 0) AND (tico_par < 81)) then
      ' copy the (absolute) read_pointer into a TiCo parameter
      p2_SET_PAR(module, ticonr, tico_par, rel_read_pointer + datapointer)
    endif
  else
    P2_GET_TICO_RingBuffer = -1 ' error: ringbuffer was in TiCo not declared for writing
  endif
ENDFUNCTION

'******************************************************************************
'''Writes values from an ADwin CPU array into a ringbuffer on the TiCo processor.
'''+Before use, please first call P2_TDRV_INIT.
'''+return: -1 error, >= 0 number of transferred values.
'''tdrv_datatable[]: array with 150 elements of type Long  
'''dest_array_no: destination(TiCo) array number.
'''src_array[]: source array.
'''src_array_idx: startindex in the source array.
'''maxcount: Max. number (1..n) of transferred values.
'''flowrate: 
'''+          1=low
'''+          2=medium
'''+          3=fast
'''tico_par:  Code number to transfer the write pointer to the TiCo processor.
'''+          1..80: Number (1..80) of global variable Par_n of the TiCo processor, into which the current write pointer value is written.
'''+          0: Write pointer value is not transferred.
'''structure: Write block size:
'''+          0: Write arbitrary number of values.
'''+         >0: The number of transferred values must be a multiple of structure.
'''******************************************************************************
FUNCTION P2_Set_TiCo_RingBuffer(tdrv_datatable[], dest_array_no, src_array[], src_array_idx, maxcount, flowrate, tico_par, structure) as Long
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long ' RAM  2 = intern 3 = extern
  dim datatype_reg as Long
  dim size as Long         ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  dim module as Long
  dim ticonr as Long
  dim tindex as Long ' readpointer ( at first :  = absolute address in TiCo memory)
  '                                 ( later :  = rel. addr. in TiCo mem. ; range : 1 ... size )
  dim count as Long
  dim count1 as Long
  dim count2 as Long
  dim read_registernr as Long
  dim regnr2 as Long        ' position of rel_write_pointer in tdrv_datatable
  dim rel_write_pointer as Long  ' pointer relative to the start of the array :  1 ... n
  dim buffer_full as Long
  dim max as Long
  dim base as long
  
#IF DEBUG_MODE = ON THEN
  dim write_registernr as Long
#ENDIF
  Check_Type_Long (tdrv_datatable[1])
  datapointer = tdrv_datatable[1 + 4 * (dest_array_no - 1)] ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  datalocation = tdrv_datatable[2 + 4 * (dest_array_no - 1)] ' RAM     2 = intern 3 = extern
  datatype_reg = tdrv_datatable[3 + 4 * (dest_array_no - 1)]
  size = tdrv_datatable[4 + 4 * (dest_array_no - 1)] - 1       ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  module = tdrv_datatable[85]
  ticonr = tdrv_datatable[86]
  ' which TiCo Indexreg is used as a read pointer ?  Actually possible values : 1, 2
  read_registernr = shift_right(datatype_reg, 24)
  if (read_registernr <> 0) then  ' Check : is this ringbuffer declared in TiCo for reading ? If not : do nothing
#IF DEBUG_MODE = ON THEN
    write_registernr = shift_right(datatype_reg, 16) AND 0FFH
    if (write_registernr <> 0) then  ' Check : is this ringbuffer declared in TiCo also for writing ?
      ' Yes ! This means, that the TiCo AS WELL AS this function wants to write
      ' to the ringbuffer. This will cause trouble  =>
      PROZESS_FEHLER = 210120  '  "TiCo Ringbuffer is declared as READ and WRITE"
      end_exit
    endif
#ENDIF
    if (datalocation = 3) then ' RAM  2 = intern 3 = extern
      regnr2 = 78 + read_registernr
      base = 680E5000h
    else
      regnr2 = 74 + read_registernr
      base = 680E4000h
    endif
    rel_write_pointer = tdrv_datatable[regnr2] ' pointer relative to the start of the array :  1 ... n
    count = 0
    count1 = 0
    count2 = 0
  
    ' = p2_get_uCore_Register(module,(base+32*(read_registernr-1))) ' get TiCos Index1 or Index2 Register
    

    tindex = Peek_P2 ((base + 512 * (read_registernr - 1)) or shift_left(module, 20))

    tindex = tindex - datapointer '  readpointer ( = relative address in TiCo memory ; range : 1 ... size )
    buffer_full = rel_write_pointer - tindex + 1 ' number of elements, which the ringbuffer contains
    if (buffer_full < 1) then buffer_full = buffer_full + size ' turnaround - check
   
    max = min_long((size - buffer_full), maxcount)
    
    IF (structure > 0) then max = (max / structure) * structure
    if (tindex <= rel_write_pointer) then
      count = min_long((size - rel_write_pointer + 1), max)
      count1 = count
      if (count > 0) then
        P2_SetData_Long(tdrv_datatable, dest_array_no, rel_write_pointer, count, src_array, src_array_idx, flowrate)
        rel_write_pointer = rel_write_pointer + count
        if (rel_write_pointer > size) then rel_write_pointer = 1
      endif
    endif
    if (tindex >= rel_write_pointer) then 
      count = min_long((tindex - rel_write_pointer + 1), (max - count1))
      count2 = count
      if (count > 0) then
        P2_SetData_Long(tdrv_datatable, dest_array_no, rel_write_pointer, count, src_array, src_array_idx + count1, flowrate)
        rel_write_pointer = rel_write_pointer + count
      endif
    endif
    P2_SET_TICO_RingBuffer = count2 + count1
    tdrv_datatable[regnr2] = rel_write_pointer
    if ((tico_par > 0) AND (tico_par < 81)) then
      ' copy the (absolute) write_pointer into a TiCo parameter
      P2_SET_PAR(module, ticonr, tico_par, rel_write_pointer + datapointer)
    endif
  else
    P2_SET_TICO_RingBuffer = -1 ' error : ringbuffer was in TiCo not declared for reading
  endif
ENDFUNCTION

'******************************************************************************
'''Returns the number of used elements in a read ringbuffer on a TiCo processor.
'''tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.
'''datano: Number (1..16) of read ringbuffer Data_n on the TiCo processor.
'''******************************************************************************
FUNCTION P2_RingBuffer_Full(tdrv_datatable[], datano) as Long
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long ' RAM  2 = intern 3 = extern
  dim datatype_reg as Long
  dim module as Long
  dim mode as Long
  dim read_registernr as Long
  dim write_registernr as Long
  dim regnr3 as Long
  dim write_pointer as Long
  dim read_pointer as Long
  dim base as long
  
  Check_Type_Long (tdrv_datatable[1])
  datapointer = tdrv_datatable[1 + 4 * (datano - 1)] ' (absolute) pointer on the start of the DATA
  datalocation = tdrv_datatable[2 + 4 * (datano - 1)] ' RAM  2 = intern 3 = extern
  datatype_reg = tdrv_datatable[3 + 4 * (datano - 1)]
    
  module = tdrv_datatable[85]
  ' which TiCo Indexreg is used as read / write pointer ?  Actually possible values : 1, 2
  read_registernr = shift_right(datatype_reg, 24) 'read
  write_registernr = shift_right(datatype_reg, 16) AND 0FFH 'write
  mode = 0
 
  if (datalocation = 3) then
    regnr3 = 78 ' read_ or write_registernr will be added later
    base = 680E5000h

  else '2,4
    regnr3 = 74 ' read_ or write_registernr will be added later
    base = 680E4000h

  endif
  
  if (read_registernr > 0) then '
    mode = 1        ' TiCo reads this ringbuffer
    'read_pointer  = p2_get_uCore_Register(module,(base+32*(read_registernr-1)))  ' get TiCos Index1 or Index2 Register
    

    read_pointer = Peek_P2 ((base + 512 * (read_registernr - 1)) or shift_left(module, 20))  

  endif
  if (write_registernr > 0) then '
    mode = mode + 2  ' TiCo writes to this ringbuffer
    'write_pointer = p2_get_uCore_Register(module,(base+32*(write_registernr-1))) ' get TiCos Index1 or Index2 Register

    write_pointer = Peek_P2 ((base + 512 * (write_registernr - 1)) or shift_left(module, 20))  

  endif


  if (mode = 0) then    ' type : no buffer at all
    P2_RingBuffer_FULL = -1  ' error
  else
    if (mode = 1) then ' TiCo does ONLY read this ringbuffer
      read_pointer = read_pointer - datapointer ' make the absolute pointer to a relative pointer
      write_pointer = tdrv_datatable[regnr3 + read_registernr] ' get (relative) pointer
    else
      if (mode = 2) then ' TiCo does ONLY write to this ringbuffer
        write_pointer = write_pointer - datapointer ' make the absolute pointer to a relative pointer
        read_pointer = tdrv_datatable[regnr3 + write_registernr] ' get (relative) pointer
        ' else
        '   (mode=3) nothing more to do for mode 3
      endif
    endif
    ' in mode 3 (read AND write) : substract absolute pointers
    ' in mode 1 and 2            : substract relative pointers
    P2_RingBuffer_FULL = write_pointer - read_pointer
    if (P2_RingBuffer_FULL < 0) then
      P2_RingBuffer_FULL = P2_RingBuffer_FULL + tdrv_datatable[4 + 4 * (datano - 1)] - 1 'size = tdrv_datatable[4 + 4 * (datano - 1)]-1
    endif
  endif
ENDFUNCTION

'******************************************************************************
'''Returns the number of free elements in a write ringbuffer on a TiCo processor.
'''tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.
'''datano: Number (1..16) of write ringbuffer Data_n on the TiCo processor.
'''******************************************************************************
FUNCTION P2_RingBuffer_Empty(tdrv_datatable[], datano) as Long
  ' dim size as Long
  dim full as Long
  Check_Type_Long (tdrv_datatable[1])
  'size = tdrv_datatable[4 + 4 * (datano - 1)]-1
  full = P2_RingBuffer_FULL(tdrv_datatable, datano)
  if (full = -1) then
    P2_RingBuffer_Empty = -1
  else
    P2_RingBuffer_Empty = tdrv_datatable[4 + 4 * (datano - 1)] - 2 - full ' size = tdrv_datatable[4 + 4 * (datano - 1)]-1
  endif
ENDFUNCTION
'<ENDREGION>


